comment "written by drizz <1of00@gmx.net>"

.686
.model flat,stdcall
option casemap:none
assume fs:nothing
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comdlg32.inc
includelib comdlg32.lib
include stdlib.inc
includelib stdlib.lib
include consolelib.inc
includelib consolelib.lib
include debugger\engine.asm


.data?
dd? patchITdestroy,teDump,hFile,pMem,pntmem,itRVA,OEP
		
.data?
InputFile db MAX_PATH dup(?)
OutputFile db MAX_PATH dup(?)

.data
TestCode db 10h dup(?) 
oldertelock db FALSE

.code
AlignTo proc dwValue:dword,dwAlignment:dword
	mov eax,dwValue
	mov ecx,dwAlignment
	dec ecx
	dec eax
	or eax,ecx
	inc eax
	ret	
AlignTo endp

DumpProcesStart proc uses edi esi ebx
LOCAL nbr,oldProt:dword
	invoke CreateFile,addr OutputFile,GENERIC_READ+GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hFile,eax
	.if eax!=INVALID_HANDLE_VALUE	
		invoke AlignTo,pNt.OptionalHeader.SizeOfImage,pNt.OptionalHeader.SectionAlignment
		invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		mov pMem,eax
		mov ebx,eax
		invoke VirtualProtectEx,pi.hProcess,ImageBase,pNt.OptionalHeader.SizeOfImage,PAGE_EXECUTE_READWRITE,addr oldProt
		invoke ReadProcessMemory,pi.hProcess,ImageBase,ebx,pNt.OptionalHeader.SizeOfImage,0
;		invoke ReadMem,ImageBase,ebx,pNt.OptionalHeader.SizeOfImage
;		; FIX DUMP!
		mov eax,ebx
		add eax,[eax].IMAGE_DOS_HEADER.e_lfanew
		mov pntmem,eax
		movzx edx,[eax].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
		m2m [eax].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment,pNt.OptionalHeader.SectionAlignment
		xor ecx,ecx
		ENTRY_RELOC   equ ((sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_BASERELOC)
		mov [eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_RELOC].VirtualAddress,ecx
		mov [eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_RELOC].isize,ecx
		ENTRY_IAT     equ ((sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_IAT)
		mov [eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_IAT].VirtualAddress,ecx
		mov [eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_IAT].isize,ecx
		add eax,sizeof IMAGE_NT_HEADERS
		.repeat
			push [eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
			pop [eax].IMAGE_SECTION_HEADER.SizeOfRawData
			push [eax].IMAGE_SECTION_HEADER.VirtualAddress
			pop [eax].IMAGE_SECTION_HEADER.PointerToRawData
			add eax,sizeof IMAGE_SECTION_HEADER
			dec edx
		.until ZERO?
		
	.endif
	ret
DumpProcesStart endp

DumpProcesEnd proc
LOCAL nbr		
	pushad
	mov edx,pntmem
	m2m [edx].IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint,OEP
	movzx ecx,[edx].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
	lea eax,[sizeof IMAGE_NT_HEADERS+edx]
	.repeat
		mov ebx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
		.if ebx <= itRVA
			add ebx,[eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
			.if ebx > itRVA
				sub ebx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
				.break
			.endif
		.endif
		mov ebx,1000h;DEF
		add eax,sizeof IMAGE_SECTION_HEADER
		dec ecx
	.until ZERO?
	ENTRY_IMPORT  equ ((sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_IMPORT)
	m2m [edx].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_IMPORT].VirtualAddress,itRVA
	mov [edx].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_IMPORT].isize,ebx
	ENTRY_RSRC    equ ((sizeof IMAGE_DATA_DIRECTORY)*IMAGE_DIRECTORY_ENTRY_RESOURCE)
	mov edi,[edx].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ENTRY_RSRC].VirtualAddress
	.if edi
		movzx ecx,[edx].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
		xor esi,esi
		lea eax,[sizeof IMAGE_NT_HEADERS+edx]
		.repeat
			mov ebx,[eax].IMAGE_SECTION_HEADER.VirtualAddress
			.if ebx <= edi
				add ebx,[eax].IMAGE_SECTION_HEADER.Misc.VirtualSize
				.if ebx > edi
					mov esi,[eax].IMAGE_SECTION_HEADER.VirtualAddress
					sub ebx,esi
					.break
				.endif
			.endif
			mov ebx,1000h;DEF
			add eax,sizeof IMAGE_SECTION_HEADER
			dec ecx
		.until ZERO?
		mov edi,ImageBase
		add edi,esi
		add esi,pMem
		invoke Writelnf,T('Resource %.8X %.8X'),edi,ebx
		invoke ReadProcessMemory,pi.hProcess,edi,esi,ebx,0
	.endif
	invoke AlignTo,pNt.OptionalHeader.SizeOfImage,pNt.OptionalHeader.SectionAlignment
	lea edx,nbr
	invoke WriteFile,hFile,pMem,eax,edx,0
	invoke VirtualFree,pMem,0,MEM_RELEASE
	invoke CloseHandle,hFile
	popad
	ret
DumpProcesEnd endp

ProcAddr macro iapi; retrieve proc addr from import table
  mov eax,iapi
  mov eax,[eax+2]
  mov eax,[eax]
  exitm <eax>
endm

.code
;////////////////////////////////////////////////////////////////////
telock_OEP proc breakaddr
	mov eax,breakaddr
	sub eax,pNt.OptionalHeader.ImageBase
	mov OEP,eax
	invoke Writelnf,T('Gotcha... OEPrva %.8X'),eax
;	invoke Getch
	invoke DumpProcesEnd
	or BREAK_DEBUGGING,TRUE
	ret
telock_OEP endp

telock_Dump proc breakaddr
LOCAL sect1[sizeof IMAGE_SECTION_HEADER]:byte
	pushad
	GetCtx
	add ctx.regEip,4
	add breakaddr,4
	SetCtx
	mov eax,ctx.regEsi
	sub eax,pNt.OptionalHeader.ImageBase
	mov itRVA,eax
	invoke Writelnf,T('Dumping now! ImportTableRVA: %.8X'),eax
;	invoke Getch
	invoke DumpProcesStart
	mov eax,pNt.OptionalHeader.ImageBase
	invoke ReadMemD,addr [eax].IMAGE_DOS_HEADER.e_lfanew
	mov esi,eax
	add esi,pNt.OptionalHeader.ImageBase
	invoke ReadMemB,addr [esi].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
	add esi,sizeof IMAGE_NT_HEADERS
	lea edx,sect1
	invoke ReadMem,esi,edx,sizeof IMAGE_SECTION_HEADER
	mov eax,sect1[0].IMAGE_SECTION_HEADER.VirtualAddress
	mov edx,sect1[0].IMAGE_SECTION_HEADER.Misc.VirtualSize
	add eax,pNt.OptionalHeader.ImageBase
	push eax
	push edx
	invoke Writelnf,T('Caching OEP... VA: %.8X, RANGE: %.8X'),eax,edx
	pop edx
	pop eax
	invoke SetBpr,eax,edx,offset telock_OEP
	invoke WriteMemB,patchITdestroy,033h; xor eax,eax
	popad
	mov eax,FALSE; continious?
	ret
telock_Dump endp

telock_VirtualFree proc breakaddr
LOCAL search[1000h]:byte,srchmem,tdumpaddr
	GetCtx
	mov eax,ctx.regEsp
	add eax,4; return offset
	invoke ReadMemD,eax	
	mov srchmem,eax
	invoke ReadMemD,eax
	.if eax == 28247c2bh
		mov oldertelock,FALSE
	.else
		or oldertelock,TRUE;	0045315F     2B7C24 28          sub edi,[esp+28]	
	.endif
	invoke Writelnf,T('call VirtualFree reached:::%.8X'),srchmem
	invoke ReadMem,srchmem,addr search,1000h
	xor ecx,ecx
	.if oldertelock
		mov edx,dword ptr [@@InstToSearch_old]
		movzx eax,word ptr [@@InstToSearch2_old]
	.else
		mov edx,dword ptr [@@InstToSearch]
		movzx eax,word ptr [@@InstToSearch2]
	.endif

	.while 1  
		.if dword ptr search [ecx] == edx; and
			mov tdumpaddr,ecx
			add ecx,4
			.while 1  
				cmp ecx,1000h-4
				jae @F
				.if word ptr search[ecx] == ax; test 
					add ecx,srchmem
					mov eax,srchmem
					add tdumpaddr,eax
					mov patchITdestroy,ecx
					invoke SetBpx,tdumpaddr,offset telock_Dump
					jmp @F
				.endif
				add ecx,1
			.endw
		.endif
		.break .if ecx > 1000h-4
		add ecx,1
	.endw
@@:	
	mov eax,FALSE; continious?
	ret
@@InstToSearch:
    and dword ptr [esi+0Ch],0
@@InstToSearch2:
    test eax,eax
@@InstToSearch_old:
    mov eax,[esi+0ch]
    db 0EBh
@@InstToSearch2_old:
    test eax,eax
telock_VirtualFree endp
;////////////////////////////////////////////////////////////////////

.code
; Function called at debug break
Dbg_OnDebugBreak proc
	pushad
	mov eax,fs:[30h]
	add eax,2
	invoke WriteMemB,eax,0
	popad
	ret
Dbg_OnDebugBreak endp
; Function called at entrypoint
Dbg_OnEnterOEP proc
	pushad
	mov esi,ProcAddr(VirtualFree)
	add esi,1; i've seen only 55:push ebp:WinXP
	; fool CC search
	; another way would be to virtualallocex and copyfirst few inst
	invoke SetBpx,esi,offset telock_VirtualFree; patch in target process space
	popad
	ret
Dbg_OnEnterOEP endp
; Function called on UNHANDLED Bpx, return TRUE if you handle it
Dbg_OnBpx proc bpxaddr
	xor eax,eax
	pushad
	popad
	ret
Dbg_OnBpx endp
; Function called on UNHANDLED Bpm, return TRUE if you handle it
Dbg_OnBpm proc bpmaddr
	xor eax,eax
	pushad
	popad
	ret
Dbg_OnBpm endp
; Function called on UNHANDLED Bpr, return TRUE if you handle it
Dbg_OnBpr proc bpraddr
	xor eax,eax;FALSE
	pushad
	popad
	ret
Dbg_OnBpr endp
; Function called on DBZ, return TRUE if you handle it
Dbg_OnDbz proc dbzaddr
	xor eax,eax;FALSE
	pushad
	popad	
	ret
Dbg_OnDbz endp
; Function called on AV, return TRUE if you handle it
Dbg_OnAccessViolation proc AVaddr:dword
	xor eax,eax;FALSE
	pushad
	popad
	ret
Dbg_OnAccessViolation endp
; Function called on UD, return TRUE if you handle it
Dbg_OnIllegalInstruction proc IIaddr:dword
	xor eax,eax;FALSE
	pushad
	popad
	ret
Dbg_OnIllegalInstruction endp


.code
ConMain proc
LOCAL ofn:OPENFILENAME
	invoke GetVersion
	.if ! (eax & 080000000h)
		invoke SetConsoleTitle,T('generic untelock by drizz (lotsa versions)')
		invoke ParamStr,0,offset InputFile,sizeof InputFile
		invoke ExtractFilePath,addr InputFile,addr InputFile
		invoke StrCat,addr InputFile,T('*.exe')
		lea edi,ofn
		mov ecx,sizeof OPENFILENAME
		xor eax,eax
		rep stosb
		mov ofn.lStructSize,sizeof OPENFILENAME
		invoke GetModuleHandle,0
		mov ofn.hInstance,eax
		mov ofn.lpstrFilter,T('Executable (*.exe only)',0,'*.EXE',0)
		mov ofn.lpstrFile,offset InputFile
		mov ofn.nMaxFile,MAX_PATH
		mov ofn.Flags,OFN_HIDEREADONLY+OFN_PATHMUSTEXIST+OFN_FILEMUSTEXIST+OFN_EXPLORER
		invoke GetOpenFileName,addr ofn
		.if eax
			invoke ExtractFilePath,addr InputFile,addr OutputFile
			invoke StrCat,addr OutputFile,T('dumped.exe')
			mov eax,TRUE
		.endif	
		invoke DbgMain,addr InputFile;T('TEST.EXE')
	.else
		invoke Writeln,T('did you know that 9x sucks for debugging?')
	.endif
	invoke Getch
	ret
ConMain endp

start:
	invoke InitConsole
	invoke ConMain
	invoke ExitProcess,eax
end start
